ServerEvents.recipes(event => {
    const shaped = event.recipes.minecraft.crafting_shaped
    const shapeless = event.shapeless



    event.remove({id: 'minecraft:coal_block'})
    event.remove({id: 'minecraft:coal'})
    event.remove({id: 'minecraft:copper_block'})
    event.remove({id: 'minecraft:copper_ingot'})
    event.remove({id: 'minecraft:diamond_block'})
    event.remove({id: 'minecraft:diamond'})
    event.remove({id: 'minecraft:emerald_block'})
    event.remove({id: 'minecraft:emerald'})
    event.remove({id: 'minecraft:gold_block'})
    event.remove({id: 'minecraft:gold_ingot_from_blasting_deepslate_gold_ore'})
    event.remove({id: 'minecraft:gold_ingot_from_blasting_raw_gold'})
    event.remove({id: 'minecraft:gold_ingot_from_gold_block'})
    event.remove({id: 'minecraft:gold_ingot_from_gold_block'})
    event.remove({id: 'minecraft:gold_ingot_from_nuggets'})
    event.remove({id: 'minecraft:gold_ingot_from_smelting_deepslate_gold_ore'})
    event.remove({id: 'minecraft:gold_ingot_from_smelting_raw_gold'})
    event.remove({id: 'minecraft:gold_nugget'})
    event.remove({id: 'minecraft:gold'})
    event.remove({id: 'minecraft:iron_block'})
    event.remove({id: 'minecraft:iron_ingot_from_blasting_deepslate_iron_ore'})
    event.remove({id: 'minecraft:iron_ingot_from_blasting_raw_iron'})
    event.remove({id: 'minecraft:iron_ingot_from_iron_block'})
    event.remove({id: 'minecraft:iron_ingot_from_nuggets'})
    event.remove({id: 'minecraft:iron_ingot_from_smelting_deepslate_iron_ore'})
    event.remove({id: 'minecraft:iron_ingot_from_smelting_raw_iron'})
    event.remove({id: 'minecraft:iron_nugget'})
    event.remove({id: 'minecraft:lapis_block'})
    event.remove({id: 'minecraft:lapis_lazuli'})
    event.remove({id: 'minecraft:netherite_block'})
    event.remove({id: 'minecraft:netherite_ingot_from_netherite_block'})
    event.remove({id: 'minecraft:netherite_ingot'})
    event.remove({id: 'minecraft:raw_copper_block'})
    event.remove({id: 'minecraft:raw_copper'})
    event.remove({id: 'minecraft:raw_gold_block'})
    event.remove({id: 'minecraft:raw_gold'})
    event.remove({id: 'minecraft:raw_iron_block'})
    event.remove({id: 'minecraft:raw_iron'})
    event.remove({id: 'minecraft:redstone_block'})
    event.remove({id: 'minecraft:redstone'})
    event.remove({id: 'minecraft:netherite_drill_smithing'})

    event.remove({id: 'alexscaves:block_of_uranium'})
    event.remove({id: 'alexscaves:furnace/gold_from_galena_ore_blasting'})
    event.remove({id: 'alexscaves:furnace/gold_from_galena_ore_smelting'})
    event.remove({id: 'alexscaves:furnace/iron_from_galena_ore_blasting'})
    event.remove({id: 'alexscaves:furnace/iron_from_galena_ore_smelting'})
    event.remove({id: 'alexscaves:furnace/uranium_from_radrock_ore_blasting'})
    event.remove({id: 'alexscaves:furnace/uranium_from_radrock_ore_smelting'})
    event.remove({id: 'alexscaves:furnace/uranium_shard_blasting'})
    event.remove({id: 'alexscaves:furnace/uranium_shard_smelting'})
    event.remove({id: 'alexscaves:uranium_from_block'})
    event.remove({id: 'alexscaves:uranium_from_shard'})
    event.remove({id: 'alexscaves:uranium_shard_from_uranium'})

    event.remove({id: 'alexsmobs:tendon_whip'})
    
    event.remove({id: 'create:blasting/gold_ingot_from_crushed'})
    event.remove({id: 'create:blasting/iron_ingot_from_crushed'})
    event.remove({id: 'create:blasting/silver_ingot_compat_oreganized'})
    event.remove({id: 'create:crafting/kinetics/empty_blaze_burner'})
    event.remove({id: 'create:crafting/materials/andesite_alloy_block'})
    event.remove({id: 'create:crafting/materials/andesite_alloy_from_block'})
    event.remove({id: 'create:crafting/materials/brass_block_from_compacting'})
    event.remove({id: 'create:crafting/materials/brass_ingot_from_compacting'})
    event.remove({id: 'create:crafting/materials/brass_ingot_from_decompacting'})
    event.remove({id: 'create:crafting/materials/brass_nugget_from_decompacting'})
    event.remove({id: 'create:crafting/materials/copper_ingot'})
    event.remove({id: 'create:crafting/materials/experience_block'})
    event.remove({id: 'create:crafting/materials/experience_nugget_from_block'})
    event.remove({id: 'create:crafting/materials/raw_zinc_block'})
    event.remove({id: 'create:crafting/materials/raw_zinc_block'})
    event.remove({id: 'create:crafting/materials/raw_zinc'})
    event.remove({id: 'create:crafting/materials/zinc_block_from_compacting'})
    event.remove({id: 'create:crafting/materials/zinc_ingot_from_compacting'})
    event.remove({id: 'create:crafting/materials/zinc_ingot_from_decompacting'})
    event.remove({id: 'create:crafting/materials/zinc_nugget_from_decompacting'})
    event.remove({id: 'create:crushing/crimsite_recycling'})
    event.remove({id: 'create:crushing/diorite_recycling'})
    event.remove({id: 'create:crushing/diorite'})
    event.remove({id: 'create:crushing/golden_horse_armor'})
    event.remove({id: 'create:crushing/iron_horse_armor'})
    event.remove({id: 'create:crushing/prismarine_crystals'})
    event.remove({id: 'create:crushing/tuff'})
    event.remove({id: 'create:milling/cobblestone'})
    event.remove({id: 'create:milling/dripstone_block'})
    event.remove({id: 'create:mixing/brass_ingot'})
    event.remove({id: 'create:smelting/gold_ingot_from_crushed'})
    event.remove({id: 'create:smelting/iron_ingot_from_crushed'})
    event.remove({id: 'create:smelting/silver_ingot_compat_oreganized'})
    event.remove({id: 'create:splashing/crushed_raw_gold'})
    event.remove({id: 'create:splashing/gravel'})
    event.remove({id: 'create:splashing/oreganized/crushed_raw_lead'})
    event.remove({id: 'create:splashing/oreganized/crushed_raw_silver'})
    event.remove({id: 'create:splashing/oreganized/crushed_silver_ore'})
    event.remove({id: 'create:splashing/sand'})

    event.remove({id: 'createdeco:industrial_iron_block'})
    event.remove({id: 'createdeco:industrial_iron_ingot_from_industrial_iron_block'})
    event.remove({id: 'createdeco:industrial_iron_ingot'})
    event.remove({id: 'createdeco:industrial_iron_nugget_from_industrial_iron_ingot'})
    event.remove({id: 'createdeco:netherite_ingot'})
    event.remove({id: 'createdeco:netherite_nugget_from_netherite_ingot'})

    event.remove({id: 'create_cogs_invaders:copper_tube_crafting'})
    event.remove({id: 'create_cogs_invaders:copper_wire_crafting'})
    event.remove({id: 'create_cogs_invaders:diamond_shard_compacting'})
    event.remove({id: 'create_cogs_invaders:impure_diamond_mixing'})
    event.remove({id: 'create_cogs_invaders:impure_diamond_polishing_using_deployer'})
    event.remove({id: 'create_cogs_invaders:impure_diamond_polishing'})

    event.remove({id: 'createdieselgenerators:crafting/diesel_engine'})
    event.remove({id: 'createdieselgenerators:crafting/hammer'})
    event.remove({id: 'createdieselgenerators:crafting/large_diesel_engine'})
    event.remove({id: 'createdieselgenerators:crafting/oil_scanner'})
    event.remove({id: 'createdieselgenerators:crafting/pumpjack_bearing'})
    event.remove({id: 'createdieselgenerators:crafting/pumpjack_head'})

    event.remove({id: 'create_henry:crafting/lapis_lazuli_from_lapis_lazuli_shard'})
    event.remove({id: 'create_henry:crafting/lapis_lazuli_shard_from_lapis_lazuli'})
    event.remove({id: 'create_henry:dragon_breathing/obsidian'})
    event.remove({id: 'create_henry:mixing/raw_rubber'})
    event.remove({id: 'create_henry:seething/crushed_raw_gold'})
    event.remove({id: 'create_henry:seething/crushed_raw_iron'})
    event.remove({id: 'create_henry:seething/netherite_scrap_from_ancient_debris'})
    event.remove({id: 'create_henry:seething/obsidian'})
    event.remove({id: 'create_henry:seething/oreganized/crushed_raw_silver'})
    event.remove({id: 'create_henry:withering/slime_ball'})
 
    event.remove({id: 'create_ironworks:materials/alloys/from_ingots/mixing_bronze'})
    event.remove({id: 'create_ironworks:materials/alloys/from_nuggets/mixing_brass'})
    event.remove({id: 'create_ironworks:materials/alloys/from_nuggets/mixing_bronze'})
    event.remove({id: 'create_ironworks:materials/alloys/from_nuggets/mixing_steel_from_charcoal'})
    event.remove({id: 'create_ironworks:materials/alloys/from_nuggets/mixing_steel_from_coal'})
    event.remove({id: 'create_ironworks:materials/bronze/crafting_block_from_ingot'})
    event.remove({id: 'create_ironworks:materials/bronze/crafting_ingot_from_block'})
    event.remove({id: 'create_ironworks:materials/bronze/crafting_ingot_from_nugget'})
    event.remove({id: 'create_ironworks:materials/rose_quartz/crafting_block_from_item'})
    event.remove({id: 'create_ironworks:materials/rose_quartz/crafting_ingot_from_block'})
    event.remove({id: 'create_ironworks:materials/steel/crafting_block_from_ingot'})
    event.remove({id: 'create_ironworks:materials/sturdy/crafting_block_from_ingot'})
    event.remove({id: 'create_ironworks:materials/sturdy/crafting_ingot_from_block'})
    event.remove({id: 'create_ironworks:materials/tin/crafting_block_from_ingot'})
    event.remove({id: 'create_ironworks:materials/tin/crafting_ingot_from_block'})
    event.remove({id: 'create_ironworks:materials/tin/crafting_ingot_from_nugget'})
    event.remove({id: 'create_ironworks:materials/tin/crafting_raw_tin_block_from_raw_tin'})
    event.remove({id: 'create_ironworks:materials/tin/crafting_raw_tin_from_raw_tin_block'})

    event.remove({id: 'create_oppenheimered:crushing/depth_charge_destruction'})
    event.remove({id: 'create_oppenheimered:crushing/uranium_ore'})

    event.remove({id: 'createoreexcavation:vein_finder'})

    event.remove({id: 'create_sa:magma_cream_recipe'})
    event.remove({id: 'create_sa:obsidian_haunting'})

    event.remove({id: 'createmetallurgy:blasting/coke_from_coal'})
    event.remove({id: 'createmetallurgy:crafting/materials/bronze_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/bronze_ingot_from_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/coke_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/coke_from_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/graphite'})
    event.remove({id: 'createmetallurgy:crafting/materials/obdurium_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/obdurium_ingot_from_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/raw_wolframite_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/raw_wolframite'})
    event.remove({id: 'createmetallurgy:crafting/materials/steel_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/steel_ingot_from_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/tungsten_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/tungsten_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/tungsten_ingot_from_block'})
    event.remove({id: 'createmetallurgy:crafting/materials/tungsten_ingot'})
    event.remove({id: 'createmetallurgy:mixing/refractory_mortar'})
    event.remove({id: 'createmetallurgy:smelting/coke_from_coal'})
    event.remove({id: 'createmetallurgy:splashing/dirty_gold_dust'})

    event.remove({id: 'create_new_age:cutting/copper_sheet'})
    event.remove({id: 'create_new_age:reactor/reactor_casing'})
    event.remove({id: 'create_new_age:shaped/generator_coil'})
    event.remove({id: 'create_new_age:thorium_multiplication'})
    event.remove({id: 'create_new_age:thorium/thorium_crushing'})

    //event.remove({id: 'createnuclear:crushing/raw_uranium_block'})
    event.remove({id: 'createnuclear:blasting/lead_ingot_for_lead_ore'})
    event.remove({id: 'createnuclear:blasting/lead_ingot_for_raw_lead'})
    event.remove({id: 'createnuclear:crafting/lead_block_from_compacting'})
    event.remove({id: 'createnuclear:crushing/fix/crushed_raw_uranium'})
    event.remove({id: 'createnuclear:crushing/granite'})
    event.remove({id: 'createnuclear:crushing/granite'})
    event.remove({id: 'createnuclear:mixing/steel'})
    event.remove({id: 'createnuclear:pressing/graphene'})
    event.remove({id: 'createnuclear:shapeless/lead_ingot_from_decompacting'})
    event.remove({id: 'createnuclear:smelting/lead_ingot_for_lead_ore'})
    event.remove({id: 'createnuclear:smelting/lead_ingot_for_raw_lead'})

    event.remove({id: 'libraryferret:blasting/iron_coins_jtl'})
    event.remove({id: 'libraryferret:smelting/iron_coins_jtl'})

    event.remove({id: 'oreganized:blast_deepslate_silver_ore'})
    event.remove({id: 'oreganized:blast_raw_silver'})
    event.remove({id: 'oreganized:create/blast_crushed_silver_ore'})
    event.remove({id: 'oreganized:create/smelt_crushed_silver_ore'})
    event.remove({id: 'oreganized:create/compatcting/molten_lead'})
    event.remove({id: 'oreganized:create/splashing/crushed_lead_ore'})
    event.remove({id: 'oreganized:create/splashing/crushed_raw_silver'})
    event.remove({id: 'oreganized:create/splashing/crushed_silver_ore'})
    event.remove({id: 'oreganized:create/splashing/crushed_silver_ore'})
    event.remove({id: 'oreganized:electrum_block'})
    event.remove({id: 'oreganized:electrum_ingot_from_block'})
    event.remove({id: 'oreganized:electrum_ingot_from_nuggets'})
    event.remove({id: 'oreganized:electrum_nugget'})
    event.remove({id: 'oreganized:netherite_ingot_from_nuggets'})
    event.remove({id: 'oreganized:silver_block'})
    event.remove({id: 'oreganized:silver_ingot_from_block'})
    event.remove({id: 'oreganized:silver_ingot_from_nuggets'})
    event.remove({id: 'oreganized:silver_nugget'})
    event.remove({id: 'oreganized:smelt_deepslate_silver_ore'})
    event.remove({id: 'oreganized:smelt_raw_silver'})
    event.remove({id: 'oreganized:lead_block'})

    event.remove({id: 'quark:building/crafting/compressed/bonded_leather_uncompress'})
    event.remove({id: 'quark:building/crafting/compressed/bonded_leather'})
    event.remove({id: 'quark:building/crafting/compressed/charcoal_block_uncompress'})
    event.remove({id: 'quark:building/crafting/compressed/charcoal_block'})
    event.remove({id: 'quark:tweaks/blasting/raw_copper_bricks_blast'})
    event.remove({id: 'quark:tweaks/blasting/raw_gold_block_blast'})
    event.remove({id: 'quark:tweaks/blasting/raw_gold_bricks_blast'})
    event.remove({id: 'quark:tweaks/blasting/raw_iron_block_blast'})
    event.remove({id: 'quark:tweaks/blasting/raw_iron_bricks_blast'})
    event.remove({id: 'quark:tweaks/smelting/raw_copper_bricks_blast'})
    event.remove({id: 'quark:tweaks/smelting/raw_gold_block_smelt'})
    event.remove({id: 'quark:tweaks/smelting/raw_gold_bricks_smelt'})
    event.remove({id: 'quark:tweaks/smelting/raw_iron_block_smelt'})
    event.remove({id: 'quark:tweaks/smelting/raw_iron_bricks_smelt'})

    event.remove({id: 'vintage:craft/spring_coiling_machine'})
    event.remove({id: 'vintage:crushing/basalt_recycling'})
    event.remove({id: 'vintage:crushing/scoria_recycling'})
    event.remove({id: 'vintage:crushing/scoria'})
    event.remove({id: 'vintage:craft/vanadium_nuggets_to_ingot'})
    event.remove({id: 'vintage:craft/vanadium_block_to_ingots'})
    event.remove({id: 'vintage:craft/vanadium_ingots_to_block'})

    event.remove({ id: /^[^/]+_(slab|wall|stairs)$/ })
    event.remove({ id: /quark:building\/crafting\/(slabs|vertslabs)\/.*/ })

    event.remove({id: 'scguns:macerator'})
    event.remove({id: 'scguns:powered_macerator'})

    event.remove({id: 'spelunkers_charm:crate_recipe'})



    event.replaceInput({mod: 'createdieselgenerators' }, 'create:andesite_alloy', '#forge:ingots/steel')



    shaped(Item.of('create:andesite_alloy'), ["NA ", "AN "], {
        N: '#forge:nuggets/bronze',
        A: 'minecraft:andesite'
    })

    shapeless(Item.of('create:polished_rose_quartz'), [
        '#forge:crystals',
        'alexsmobs:bison_fur'
    ]).keepIngredient('alexsmobs:bison_fur')

    shapeless(Item.of('create_new_age:copper_wire'), [
        "create_cogs_invaders:copper_wire", 
        "create_henry:rubber"
    ])

    shaped(Item.of('createmetallurgy:sturdy_whisk'), [" A ", "SAS", "BSB"], {
        S: 'alexsmobs:fish_bones',
        A: 'create:andesite_alloy',
        B: 'alexsmobs:moose_headgear'
    })

    shaped(Item.of('createdieselgenerators:hammer'), ["AIA", "ISI", "SIA"], {
        S: 'minecraft:stick',
        A: 'create:andesite_alloy',
        I: '#forge:ingots'
    })

    shaped(Item.of('createdieselgenerators:pumpjack_head'), ["S S", "AWA", "S S"], {
        W: 'alexsmobs:vine_lasso',
        A: 'create:andesite_alloy',
        S: '#forge:ingots/steel'
    })

    shaped(Item.of('createdieselgenerators:pumpjack_bearing'), ["SZS", "ZBZ", "SZS"], {
        B: 'create:mechanical_bearing',
        Z: '#forge:storage_blocks/zinc',
        S: '#forge:storage_blocks/steel'
    })

    shaped(Item.of('create:empty_blaze_burner'), [" P ", "PBP", " P "], {
        B: '#forge:netherrack',
        P: '#forge:plates'
    })

    shaped(Item.of('create:blaze_burner'), [" M ", "MEM", "BBB"], {
        M: 'minecraft:magma_block',
        E: 'create:empty_blaze_burner',
        B: '#forge:basalt_blocks'
    })

    shaped(Item.of('createmetallurgy:refractory_mortar'), ["SCS", "CSC", "SCS"], {
        S: '#forge:sand',
        C: 'kubejs:fireclay_ball'
    })

    shaped(Item.of('createdieselgenerators:oil_scanner'), [ 'SLS', 'PRP', ' R '], {
        S: '#forge:ingots/steel',
        L: 'alexsmobs:echolocator',
        P: '#forge:plates/iron',
        R: 'vintage:zinc_rod'
    })

    shaped(Item.of('createdieselgenerators:diesel_engine'), [ ' F ', 'PBP', 'STS'], {
        F: 'minecraft:flint_and_steel',
        P: 'createdieselgenerators:engine_piston',
        B: '#forge:storage_blocks/brass',
        T: 'create:fluid_tank',
        S: 'alexscaves:abyssmarine_slab'
    })

    shaped(Item.of('createdieselgenerators:large_diesel_engine'), [ ' I ', 'BEB', ' S '], {
        E: 'createdieselgenerators:diesel_engine',
        B: '#forge:plates/brass',
        I: 'createmetallurgy:steel_ingot',
        S: 'alexscaves:abyssmarine_slab'
    })

    shaped(Item.of('vintage:spring_coiling_machine'), [ 'A  ', 'CNS', 'A  '], {
        C: 'vintage:spring_coiling_machine_wheel',
        N: 'create:andesite_casing',
        S: 'create:shaft',
        A: 'create:andesite_alloy',
    })

    shaped(Item.of('vintage:vanadium_ingot'), [ 'AAA', 'AAA', 'AAA'], {
        A: 'protection_pixel:heatresistantceramicsheet'
    })

    shaped(Item.of('createoreexcavation:vein_finder'), [ 'EA ', 'RS ', '  S'], {
        E: 'alexsmobs:endolocator',
        A: 'minecraft:amethyst_shard',
        R: '#minecraft:redstone_ores',
        S: 'minecraft:stick',
    })

    shaped(Item.of('chunkloaders:single_chunk_loader'), [ 'OOO', 'TET', 'DDD'], {
        O: 'minecraft:obsidian',
        T: 'minecraft:ghast_tear',
        E: 'minecraft:ender_eye',
        D: 'minecraft:diamond_block'
    })

    shaped(Item.of('alexscaves:dinosaur_chop'), [ 'CCC', 'BBB', 'CCC'], {
        C: 'minecraft:chicken',
        B: 'minecraft:bone'
    })

    shaped(Item.of('createoreexcavation:netherite_drill'), [ 'BI ', 'IDI', ' II'], {
        B: 'create_new_age:solid_corium',
        I: 'minecraft:netherite_ingot',
        D: 'createoreexcavation:diamond_drill'
    })

    shaped(Item.of('scguns:macerator'), ['P P', 'PFP', 'SSS'], {
        P: 'minecraft:diorite_slab',
        F: 'minecraft:blast_furnace',
        S: '#forge:storage_blocks/steel'
    })

    shaped(Item.of('kubejs:fireclay_ball'), ['BBB', 'BCB', 'BBB'], {
        B: 'minecraft:bone_meal',
        C: 'minecraft:clay_ball'
    })

    shapeless(Item.of('scguns:powered_macerator'), ['scguns:macerator', 'scguns:lightning_battery'])
    
    shapeless(Item.of('minecraft:flint_and_steel'), ['#forge:ingots/bronze', 'minecraft:flint'])

})

